#include <amxmodx>
#include <amxmisc>
#include <fakemeta>

new Float:CTFlagloc[3]
new Float:TFlagloc[3]
new togglecvar, flagtype, flag1, flag2
new beamsprite
new flag1str[32], flag2str[32]
new flag1ent, flag2ent

public plugin_init()
{
	register_plugin("GHW CTF Flag Handler","1.0","GHW_Chronic")

	togglecvar = get_cvar_pointer("ctf_enabled")

	set_task(20.0,"draw_flagstand",0,"",0,"b")

	set_task(2.0,"get_locs")
}

public plugin_precache()
{
	flagtype = register_cvar("ctf_flagtype","1")
	flag1 = register_cvar("ctf_flag_model_1","models/red_flag.mdl")
	flag2 = register_cvar("ctf_flag_model_2","models/blue_flag.mdl")

	beamsprite = precache_model("sprites/dot.spr")
	if(get_pcvar_num(flagtype)==2)
	{
		get_pcvar_string(flag1,flag1str,31)
		get_pcvar_string(flag2,flag2str,31)
		if(file_exists(flag1str) && file_exists(flag2str) && precache_model(flag1str) && precache_model(flag2str))
		{
			create_flag_ent()
		}
	}
}

public get_locs()
{
	callfunc_begin("ctlocation","GHW_CTF_flagspawn_finder.amxx")
	callfunc_push_floatrf(CTFlagloc[0])
	callfunc_push_floatrf(CTFlagloc[1])
	callfunc_push_floatrf(CTFlagloc[2])
	callfunc_end()

	callfunc_begin("tlocation","GHW_CTF_flagspawn_finder.amxx")
	callfunc_push_floatrf(TFlagloc[0])
	callfunc_push_floatrf(TFlagloc[1])
	callfunc_push_floatrf(TFlagloc[2])
	callfunc_end()

	set_task(2.0,"draw_flagstand")
}

public draw_flagstand()
{
	if(get_pcvar_num(togglecvar))
	{
		draw_flagstand2(1,10,10,40)
		draw_flagstand2(1,-10,10,40)
		draw_flagstand2(1,10,-10,40)
		draw_flagstand2(1,-10,-10,40)
		draw_flagstand2(2,10,10,40)
		draw_flagstand2(2,-10,10,40)
		draw_flagstand2(2,10,-10,40)
		draw_flagstand2(2,-10,-10,40)
	}
}

public draw_flagstand2(team,x,y,z)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
	write_byte(0)		//TE_BEAMPOINTS
	switch(team)
	{
		case 1:
		{
			write_coord(floatround(TFlagloc[0]))
			write_coord(floatround(TFlagloc[1]))
			write_coord(floatround(TFlagloc[2]))
			write_coord(floatround(TFlagloc[0]) - x)
			write_coord(floatround(TFlagloc[1]) - y)
			write_coord(floatround(TFlagloc[2]) - z)
		}
		case 2:
		{
			write_coord(floatround(CTFlagloc[0]))
			write_coord(floatround(CTFlagloc[1]))
			write_coord(floatround(CTFlagloc[2]))
			write_coord(floatround(CTFlagloc[0]) - x)
			write_coord(floatround(CTFlagloc[1]) - y)
			write_coord(floatround(CTFlagloc[2]) - z)
		}
	}
	write_short(beamsprite)
	write_byte(1)		// framestart
	write_byte(1)		// framerate
	write_byte(200)		// life in 0.1's
	write_byte(5)		// width
	write_byte(0)		// noise
	write_byte(10)		// red
	write_byte(255)		// green
	write_byte(10)		// blue
	write_byte(200)		// brightness
	write_byte(0)		// speed
	message_end()
}

public create_flag_ent()
{
	flag1ent = engfunc(EngFunc_CreateNamedEntity,engfunc(EngFunc_AllocString,"info_target"))
	set_pev(flag1ent,pev_classname,"ghw_t_flag")
	set_pev(flag1ent,pev_movetype,MOVETYPE_FLY)
	set_pev(flag1ent,pev_solid,SOLID_NOT)
	set_pev(flag1ent,pev_framerate,1.0)
	set_pev(flag1ent,pev_sequence,1)
	set_pev(flag1ent,pev_gaitsequence,1)
	engfunc(EngFunc_SetModel,flag1ent,flag1str)

	flag2ent = engfunc(EngFunc_CreateNamedEntity,engfunc(EngFunc_AllocString,"info_target"))
	set_pev(flag2ent,pev_classname,"ghw_ct_flag")
	set_pev(flag2ent,pev_movetype,MOVETYPE_FLY)
	set_pev(flag2ent,pev_solid,SOLID_NOT)
	set_pev(flag2ent,pev_framerate,1.0)
	set_pev(flag2ent,pev_sequence,1)
	set_pev(flag2ent,pev_gaitsequence,1)
	engfunc(EngFunc_SetModel,flag2ent,flag2str)

	set_pev(flag1ent,pev_origin,Float:{4000.0, 4000.0, 4000.0})
	set_pev(flag2ent,pev_origin,Float:{4000.0, 4000.0, 4000.0})
}

public draw_flag(flagnum,Float:x,Float:y,Float:z)
{
	if(get_pcvar_num(togglecvar))
	{
		if(get_pcvar_num(flagtype)==1 || !flag1ent)
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
			write_byte(0)		//TE_BEAMPOINTS
			write_coord(floatround(x))
			write_coord(floatround(y))
			write_coord(floatround(z))
			write_coord(floatround(x))
			write_coord(floatround(y))
			write_coord(floatround(z) + 30)
			write_short(beamsprite)
			write_byte(1)
			write_byte(1)
			write_byte(1)
			write_byte(5)
			write_byte(0)
			write_byte(255)
			write_byte(255)
			write_byte(255)
			write_byte(200)
			write_byte(0)
			message_end()

			message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
			write_byte(0)
			write_coord(floatround(x))
			write_coord(floatround(y))
			write_coord(floatround(z) + 23)
			write_coord(floatround(x))
			write_coord(floatround(y))
			write_coord(floatround(z) + 30)
			write_short(beamsprite)
			write_byte(1)
			write_byte(1)
			write_byte(1)
			write_byte(40)
			write_byte(0)
			if(flagnum==1)
			{
				write_byte(255)
				write_byte(0)
				write_byte(0)
			}
			else
			{
				write_byte(0)
				write_byte(0)
				write_byte(255)
			}

			write_byte(200)
			write_byte(0)
			message_end()
		}
		else if(pev_valid(flag1ent) && pev_valid(flag2ent))
		{
			static Float:origin[3]
			origin[0] = x
			origin[1] = y
			origin[2] = z
			if(flagnum==1) set_pev(flag1ent,pev_origin,origin)
			else set_pev(flag2ent,pev_origin,origin)
		}
	}
}
