#include <amxmodx>
#include <amxmisc>
#include <fakemeta>

new Float:CTSpawnloc[3]
new Float:TSpawnloc[3]

new configfile[200]

public plugin_init()
{
	register_plugin("GHW CTF Flagspawn Finder","1.0","GHW_Chronic")

	register_concmd("amx_ctf_ctflag","make_ct_loc",ADMIN_KICK,"Set location of CT flagstand to current location")
	register_concmd("amx_ctf_tflag","make_t_loc",ADMIN_KICK,"Set location of T flagstand to current location")

	get_configsdir(configfile,199)
	format(configfile,199,"%s/CTF_spawnlocs.ini",configfile)

	set_task(1.0,"find_locs")
}

public find_locs()
{
	new mapname[32]
	get_mapname(mapname,31)
	format(mapname,31,"%s-CT",mapname)
	new bool:found
	if(file_exists(configfile))
	{
		new read[32], trash, fsize = file_size(configfile,1)
		for(new i=0;i<fsize;i++)
		{
			read_file(configfile,i,read,31,trash)
			if(equali(read,mapname))
			{
				read_file(configfile,i+1,read,31,trash)
				CTSpawnloc[0] = str_to_float(read)
				read_file(configfile,i+2,read,31,trash)
				CTSpawnloc[1] = str_to_float(read)
				read_file(configfile,i+3,read,31,trash)
				CTSpawnloc[2] = str_to_float(read)

				found=true
				break;
			}
		}
	}
	if(!found)
	{
		new ent = engfunc(EngFunc_FindEntityByString,get_maxplayers(),"classname","info_player_start")
		if(ent) pev(ent,pev_origin,CTSpawnloc)
	}

	get_mapname(mapname,31)
	format(mapname,31,"%s-T",mapname)
	found=false
	if(file_exists(configfile))
	{
		new read[32], trash, fsize = file_size(configfile,1)
		for(new i=0;i<fsize;i++)
		{
			read_file(configfile,i,read,31,trash)
			if(equali(read,mapname))
			{
				read_file(configfile,i+1,read,31,trash)
				TSpawnloc[0] = str_to_float(read)
				read_file(configfile,i+2,read,31,trash)
				TSpawnloc[1] = str_to_float(read)
				read_file(configfile,i+3,read,31,trash)
				TSpawnloc[2] = str_to_float(read)

				found=true
				break;
			}
		}
	}
	if(!found)
	{
		new ent = engfunc(EngFunc_FindEntityByString,get_maxplayers(),"classname","info_player_deathmatch")
		if(ent) pev(ent,pev_origin,TSpawnloc)
	}
}

public ctlocation(& Float:x,& Float:y,& Float:z)
{
	x=CTSpawnloc[0]
	y=CTSpawnloc[1]
	z=CTSpawnloc[2]
	return 1;
}

public tlocation(& Float:x,& Float:y,& Float:z)
{
	x=TSpawnloc[0]
	y=TSpawnloc[1]
	z=TSpawnloc[2]
	return 1;
}

public make_ct_loc(id)
{
	pev(id,pev_origin,CTSpawnloc)

	new mapname[32]
	get_mapname(mapname,31)
	format(mapname,31,"%s-CT",mapname)

	new bool:written
	if(file_exists(configfile))
	{
		new read[32], trash, fsize = file_size(configfile,1)
		for(new i=0;i<fsize;i++)
		{
			read_file(configfile,i,read,31,trash)
			if(equali(read,mapname))
			{
				new string[32]
				format(string,31,"%f",CTSpawnloc[0])
				write_file(configfile,string,i+1)
				format(string,31,"%f",CTSpawnloc[1])
				write_file(configfile,string,i+2)
				format(string,31,"%f",CTSpawnloc[2])
				write_file(configfile,string,i+3)
				written=true
				break;
			}
		}
	}
	if(!written)
	{
		write_file(configfile,mapname,-1)
		new string[32]
		format(string,31,"%f",CTSpawnloc[0])
		write_file(configfile,string,-1)
		format(string,31,"%f",CTSpawnloc[1])
		write_file(configfile,string,-1)
		format(string,31,"%f",CTSpawnloc[2])
		write_file(configfile,string,-1)
	}

	callfunc_begin("get_locs","GHW_CTF_flag.amxx")
	callfunc_end()
	callfunc_begin("get_locs","GHW_CTF_cap_monitor.amxx")
	callfunc_end()
	client_print(id,print_chat,"[GHW-CTF] New CT flagstand location set.")
	return PLUGIN_HANDLED
}

public make_t_loc(id)
{
	pev(id,pev_origin,TSpawnloc)

	new mapname[32]
	get_mapname(mapname,31)
	format(mapname,31,"%s-T",mapname)

	new bool:written
	if(file_exists(configfile))
	{
		new read[32], trash, fsize = file_size(configfile,1)
		for(new i=0;i<fsize;i++)
		{
			read_file(configfile,i,read,31,trash)
			if(equali(read,mapname))
			{
				new string[32]
				format(string,31,"%f",TSpawnloc[0])
				write_file(configfile,string,i+1)
				format(string,31,"%f",TSpawnloc[1])
				write_file(configfile,string,i+2)
				format(string,31,"%f",TSpawnloc[2])
				write_file(configfile,string,i+3)
				written=true
				break;
			}
		}
	}
	if(!written)
	{
		write_file(configfile,mapname,-1)
		new string[32]
		format(string,31,"%f",TSpawnloc[0])
		write_file(configfile,string,-1)
		format(string,31,"%f",TSpawnloc[1])
		write_file(configfile,string,-1)
		format(string,31,"%f",TSpawnloc[2])
		write_file(configfile,string,-1)
	}

	callfunc_begin("get_locs","GHW_CTF_flag.amxx")
	callfunc_end()
	callfunc_begin("get_locs","GHW_CTF_cap_monitor.amxx")
	callfunc_end()
	client_print(id,print_chat,"[GHW-CTF] New T flagstand location set.")
	return PLUGIN_HANDLED
}
