#include <amxmodx>
#include <amxmisc>
#include <fun>
#include <cstrike>
#include <engine>

//Used for create_middle functions
#define tag_sprite_size_horizontal	4000
#define tag_sprite_size_vertical	1000
#define tag_sprite_vertical_increments	5

#define CTFLAGMODEL	"models/ctflag.mdl"
#define TFLAGMODEL	"models/tflag.mdl"

new bool:flag_exists=false
new ctflagent
new tflagent

//Calculate where to draw the flag + the flag stand (CT)
new CTFlag_stand[3]
new CTFlag_deathspot[3]
new CTFlag_holder

//Calculate where to draw the flag + the flag stand (T)
new TFlag_stand[3]
new TFlag_deathspot[3]
new TFlag_holder

//For create_middle functions.
new Float: farthest_point1[3]
new Float: farthest_point2[3]

//incase there aren't any info_play_start/deathmatch entities.
new bool:stopplugin

//Sprite that we precache
new beamsprite

//Spawn protection + spawn bug fix variables.
new bool:can_respawn[33]
new spawntimeleft[33]
new bool:tagged[33]

//Keep track of score
new Tcount
new CTcount

//Maps.ini (for end round map change)
new mapfile[32]

//Added for Multi-Lingual Support in version 1.2
new clientcmd_spawn[32]
new clientcmd_help[32]
new cvar_ctf_spawntime[32]
new cvar_ctf_tagmode[32]
new cvar_ctf_enabled[32]
new cvar_ctf_kill_reward[32]
new cvar_ctf_capture_reward[32]
new cvar_ctf_capture_limit[32]

public plugin_init()
{
	//Language File
	register_dictionary("GHW_CTF.txt")

	new pluginname[32]
	format(pluginname,31,"GHW - %L",LANG_SERVER,"PLUGIN_NAME")
	register_plugin(pluginname,"1.4","GHW_Chronic")

	new command1[32]
	format(command1,31,"%L",LANG_SERVER,"TOGGLE_TAG_COMMAND")
	new command2[32]
	format(command2,31,"%L",LANG_SERVER,"TOGGLE_COMMAND")

	new command_description1[32]
	format(command_description1,31,"%L",LANG_SERVER,"TOGGLE_TAG")
	new command_description2[32]
	format(command_description2,31,"%L",LANG_SERVER,"TOGGLE")

	//Tag Toggle
	register_concmd(command1,"cvar_toggle",ADMIN_CVAR,command_description1)

	//CTF Toggle
	register_concmd(command2,"cvar2_toggle",ADMIN_CVAR,command_description2)

	new client_command11[32]
	new client_command12[32]
	new client_command13[32]
	format(client_command11,31,"%L",LANG_SERVER,"SPAWN")
	format(clientcmd_spawn,31,"/%s",client_command11)
	format(client_command12,31,"say %s",clientcmd_spawn)
	format(client_command13,31,"say_team %s",clientcmd_spawn)

	new client_command21[32]
	new client_command22[32]
	new client_command23[32]
	format(client_command21,31,"%L",LANG_SERVER,"HELP")
	format(clientcmd_help,31,"/ctf_%s",client_command21)
	format(client_command22,31,"say %s",clientcmd_help)
	format(client_command23,31,"say_taem %s",clientcmd_help)


	register_clcmd(client_command12,"spawn3")
	register_clcmd(client_command13,"spawn3")
	register_clcmd(client_command22,"hook_say_help")
	register_clcmd(client_command23,"hook_say_help")

	register_event("DeathMsg","DeathMsg","a")
	register_event("CurWeapon","drop_c4","be","1=1","2=6")
	register_event("SendAudio","newround","a","2=%!MRAD_terwin","2=%!MRAD_ctwin","2=%!MRAD_rounddraw")

	//Thank you teame06 for this part.
	register_menucmd(register_menuid("Terrorist_Select",1), 511,"team_select")
	register_menucmd(register_menuid("CT_Select",1),511,"team_select")
	register_clcmd("joinclass","team_select")

	format(cvar_ctf_spawntime,31,"ctf_%L",LANG_SERVER,"SPAWNTIME")
	format(cvar_ctf_tagmode,31,"ctf_%L",LANG_SERVER,"TAGMODE")
	format(cvar_ctf_enabled,31,"ctf_%L",LANG_SERVER,"ENABLED")
	format(cvar_ctf_kill_reward,31,"ctf_%L",LANG_SERVER,"KILLREWARD")
	format(cvar_ctf_capture_reward,31,"ctf_%L",LANG_SERVER,"CAPTUREREWARD")
	format(cvar_ctf_capture_limit,31,"ctf_%L",LANG_SERVER,"CAPTURELIMIT")

	register_cvar(cvar_ctf_spawntime,"6")
	register_cvar(cvar_ctf_tagmode,"0")
	register_cvar(cvar_ctf_enabled,"1")
	register_cvar(cvar_ctf_kill_reward,"1000")
	register_cvar(cvar_ctf_capture_reward,"1500")
	register_cvar(cvar_ctf_capture_limit,"25")
	register_cvar("ctf_fence","0")
	register_cvar("ctf_spawntime2","0.0")
	register_cvar("ctf_flagmodels","0")

	set_task(1.0,"find_flagpos")
	set_task(2.0,"create_middle1")
	set_task(15.0,"create_middle2",0,"",0,"b")
	set_task(10.0,"draw_flag_stands",0,"",0,"b")
	set_task(0.1,"draw_flags",0,"",0,"b")
	set_task(300.1,"Advertise",0,"",0,"b")
	set_task(200.7,"Remove_Weapons",0,"",0,"b")

	stopplugin=false
	CTFlag_holder=0
	TFlag_holder=0
	Tcount=0
	CTcount=0

	new configsdir[32]
	get_configsdir(configsdir,31)
	format(mapfile,31,"%s/maps.ini",configsdir)
}


/*****************************************
 Set client variables on entrance / exit.
*****************************************/

public client_putinserver(id)
{
	tagged[id]=false
	set_task(0.3,"prethink",id,"",0,"b")
	can_respawn[id]=false
	spawntimeleft[id]=0
	return PLUGIN_CONTINUE
}

public client_disconnect(id)
{
	if(TFlag_holder==id)
	{
		TFlag_holder=-1
	}
	if(CTFlag_holder==id)
	{
		CTFlag_holder=-1
	}
	if(id!=0)
	{
		remove_task(id)
	}
	return PLUGIN_CONTINUE
}

public plugin_precache()
{
	beamsprite = precache_model("sprites/dot.spr")
	if(file_exists(CTFLAGMODEL) && file_exists(TFLAGMODEL))
	{
		flag_exists=true
		precache_model(CTFLAGMODEL)
		precache_model(TFLAGMODEL)
		ctflagent = create_flag_entities(2)
		tflagent = create_flag_entities(1)
	}
}

public team_select(id,key)
{
	if(get_cvar_num(cvar_ctf_enabled))
	{
		set_task(2.0,"spawn1",id)
	}
}


/***********************
 Creates flag entities.
***********************/
public create_flag_entities(type)
{
	new ent = create_entity("info_target")
	entity_set_string(ent,EV_SZ_classname,"ghw_health")

	if(type==2) entity_set_model(ent,CTFLAGMODEL)
	if(type==1) entity_set_model(ent,TFLAGMODEL)

	new Float:origin[3]
	origin[0] = 9999.0
	origin[1] = 9999.0
	origin[2] = 9999.0
	entity_set_origin(ent,origin)

	entity_set_int(ent, EV_INT_solid,SOLID_BBOX)
	entity_set_int(ent,EV_INT_movetype,MOVETYPE_FLY)
	entity_set_edict(ent,EV_ENT_owner,33)

	entity_set_float(ent,EV_FL_framerate,1.0)
	entity_set_int(ent,EV_INT_sequence,0)

	new Float:mina[3]
	mina[0]=-0.1
	mina[1]=-0.1
	mina[2]=-0.1
	new Float:maxa[3]
	maxa[0]=0.1
	maxa[1]=0.1
	maxa[2]=0.1
	entity_set_size(ent,mina,maxa) 

	return ent;
}


/*****************************
 Changes map on team winning.
*****************************/

public check_scores()
{
	if(get_cvar_num(cvar_ctf_capture_limit) && Tcount>=get_cvar_num(cvar_ctf_capture_limit))
	{
		client_print(0,print_chat,"%L",LANG_PLAYER,"TWIN")
		client_print(0,print_chat,"%L",LANG_PLAYER,"TWIN")
		client_print(0,print_chat,"%L",LANG_PLAYER,"TWIN")
		set_task(15.0,"change_map")
	}
	if(get_cvar_num(cvar_ctf_capture_limit) && CTcount>=get_cvar_num(cvar_ctf_capture_limit))
	{
		client_print(0,print_chat,"%L",LANG_PLAYER,"CTWIN")
		client_print(0,print_chat,"%L",LANG_PLAYER,"CTWIN")
		client_print(0,print_chat,"%L",LANG_PLAYER,"CTWIN")
		set_task(15.0,"change_map")
	}
	return PLUGIN_HANDLED
}

public change_map()
{
	if(!file_exists(mapfile))
	{
		switch(random_num(0,4))
		{
			case 0: server_cmd("amx_votemap cs_assault")
			case 1: server_cmd("amx_votemap de_dust")
			case 2: server_cmd("amx_votemap de_dust2")
			case 3: server_cmd("amx_votemap de_aztec")
			case 4: server_cmd("amx_votemap de_inferno")
		}
		return PLUGIN_HANDLED
	}
	new read[32]
	new trash
	new mapname[32]
	get_mapname(mapname,31)
	for(new i=0;i<=file_size(mapfile) - 2;i++)
	{
		read_file(mapfile,i,read,31,trash)
		if(equali(mapname,read))
		{
			new read2[32]
			read_file(mapfile,i,read2,31,trash)
			server_cmd("changelevel %s",read2)
			return PLUGIN_HANDLED
		}
	}
	read_file(mapfile,0,read,31,trash)
	server_cmd("changelevel %s",read)
	return PLUGIN_HANDLED
}

/*********************************************************
 A. Enforce Spawn Protection.
 B. See if a player touched the flag.
 C. See if a player captures the flag.
 D. Show "flag location" hudmessages
 E. strip weapons on "tag" mode.
*********************************************************/

//Called every 0.3 seconds instead of engine's 0.1.
public prethink(id)
{
	if(stopplugin || !get_cvar_num(cvar_ctf_enabled) || !is_user_connected(id))
	{
		return PLUGIN_CONTINUE
	}
	if(spawntimeleft[id]>0 && !get_cvar_num(cvar_ctf_tagmode))
	{
		set_user_health(id,1380)
		client_cmd(id,"weapon_knife;-attack;-attack2")
	}
	new idorigin[3]
	get_user_origin(id,idorigin)
	new name[32]
	get_user_name(id,name,31)
	
	new team[32]
	get_user_team(id,team,31)
	new teamnum=1
	if(containi(team,"CT")!=-1 || containi(team,"Counter")!=-1)
	{
		teamnum=2
	}
	if(!spawntimeleft[id] && TFlag_holder!=id && CTFlag_holder!=id && is_user_alive(id))
	{
		if(!tagged[id] || !get_cvar_num(cvar_ctf_enabled))
		{
			new CTFlag_origin[3]
			new TFlag_origin[3]
			if(!CTFlag_holder)
			{
				CTFlag_origin[0] = CTFlag_stand[0]
				CTFlag_origin[1] = CTFlag_stand[1]
				CTFlag_origin[2] = CTFlag_stand[2]
			}
			if(!TFlag_holder)
			{
				TFlag_origin[0] = TFlag_stand[0]
				TFlag_origin[1] = TFlag_stand[1]
				TFlag_origin[2] = TFlag_stand[2]
			}
			if(CTFlag_holder!=-1 && CTFlag_holder)
			{
				get_user_origin(CTFlag_holder,CTFlag_origin)
			}
			if(TFlag_holder!=-1 && TFlag_holder)
			{
				get_user_origin(TFlag_holder,TFlag_origin)
			}
			if(CTFlag_holder==-1)
			{
				CTFlag_origin[0] = CTFlag_deathspot[0]
				CTFlag_origin[1] = CTFlag_deathspot[1]
				CTFlag_origin[2] = CTFlag_deathspot[2]
			}
			if(TFlag_holder==-1)
			{
				TFlag_origin[0] = TFlag_deathspot[0]
				TFlag_origin[1] = TFlag_deathspot[1]
				TFlag_origin[2] = TFlag_deathspot[2]
			}
			
			if(get_distance(idorigin,TFlag_origin)<=40)
			{
				if(teamnum==1)
				{
					if(TFlag_holder==-1)
					{
						TFlag_holder=0
						client_print(0,print_chat,"",LANG_PLAYER,"RETURNT",name)
					}
				}
				if(teamnum==2)
				{
					if(!TFlag_holder || TFlag_holder==-1)
					{
						TFlag_holder=id
						client_print(0,print_chat,"%L",LANG_PLAYER,"GRABT",name)
					}
				}
			}
			if(get_distance(idorigin,CTFlag_origin)<=40)
			{
				if(teamnum==2)
				{
					if(CTFlag_holder==-1)
					{
						CTFlag_holder=0
						client_print(0,print_chat,"%L",LANG_PLAYER,"RETURNCT",name)
					}
				}
				if(teamnum==1)
				{
					if(!CTFlag_holder || CTFlag_holder==-1)
					{
						CTFlag_holder=id
						client_print(0,print_chat,"%L",LANG_PLAYER,"GRABCT",name)
					}
				}
			}
		}
	}
	
	if(TFlag_holder==id && !CTFlag_holder && get_distance(idorigin,CTFlag_stand)<=40)
	{
		TFlag_holder=0
		client_print(0,print_chat,"%L",LANG_PLAYER,"CAPTURET",name)
		client_print(id,print_chat,"%L",id,"CAPTUREREWARDED",get_cvar_num(cvar_ctf_capture_reward))
		cs_set_user_money(id,cs_get_user_money(id) + get_cvar_num(cvar_ctf_capture_reward))
		CTcount++
		check_scores()
	}
	if(CTFlag_holder==id && !TFlag_holder && get_distance(idorigin,TFlag_stand)<=40)
	{
		CTFlag_holder=0
		client_print(0,print_chat,"%L",LANG_PLAYER,"CAPTURECT",name)
		client_print(id,print_chat,"%L",id,"CAPTUREREWARDED",get_cvar_num(cvar_ctf_capture_reward))
		cs_set_user_money(id,cs_get_user_money(id) + get_cvar_num(cvar_ctf_capture_reward))
		Tcount++
		check_scores()
	}
	if(teamnum==1 && tagged[id] && get_distance(idorigin,TFlag_stand)<=40)
	{
		tagged[id]=false
		client_print(id,print_chat,"%L",id,"UNTAGGED",name)
		set_user_rendering(id,kRenderFxNone,0,0,0,kRenderNormal,0)
	}
	
	if(teamnum==2 && tagged[id] && get_distance(idorigin,CTFlag_stand)<=40)
	{
		tagged[id]=false
		client_print(id,print_chat,"%L",id,"UNTAGGED",name)
		set_user_rendering(id,kRenderFxNone,0,0,0,kRenderNormal,0)
	}


	set_hudmessage(255,0,0,-1.0,0.0,0,6.0,0.3,0.1,0.2,1)

	if(TFlag_holder==-1)
	{
		show_hudmessage(0,"%L: %d  |  %L: %L",LANG_PLAYER,"TSCORE",Tcount,LANG_PLAYER,"TLOCATION",LANG_PLAYER,"ONGROUND")
	}
	if(TFlag_holder>0)
	{
		new name[32]
		get_user_name(TFlag_holder,name,31)
		show_hudmessage(0,"%L: %d  |  %L: %s",LANG_PLAYER,"TSCORE",Tcount,LANG_PLAYER,"TLOCATION",name)
	}
	if(!TFlag_holder)
	{
		show_hudmessage(0,"%L: %d  |  %L: %L",LANG_PLAYER,"TSCORE",Tcount,LANG_PLAYER,"TLOCATION",LANG_PLAYER,"TBASE")
	}

	set_hudmessage(0,0,255,-1.0,0.05,0,6.0,0.3,0.1,0.2,2)

	if(CTFlag_holder==-1)
	{
		show_hudmessage(0,"%L: %d  |  %L: %L",LANG_PLAYER,"CTSCORE",Tcount,LANG_PLAYER,"CTLOCATION",LANG_PLAYER,"ONGROUND")
	}
	if(CTFlag_holder>0)
	{
		new name[32]
		get_user_name(CTFlag_holder,name,31)
		show_hudmessage(0,"%L: %d  |  %L: %s",LANG_PLAYER,"CTSCORE",CTcount,LANG_PLAYER,"CTLOCATION",name)
	}
	if(!CTFlag_holder)
	{
		show_hudmessage(0,"%L: %d  |  %L: %L",LANG_PLAYER,"CTSCORE",CTcount,LANG_PLAYER,"CTLOCATION",LANG_PLAYER,"CTBASE")
	}

	if(get_cvar_num(cvar_ctf_tagmode))
	{
		strip_user_weapons(id)
	}
	return PLUGIN_CONTINUE
}


/*******************************
 Handles tagging in "tag" mode.
*******************************/

public pfn_touch(ptr,ptd)
{
	if(stopplugin || !get_cvar_num(cvar_ctf_enabled) || !get_cvar_num(cvar_ctf_tagmode))
	{
		return PLUGIN_CONTINUE
	}
	if(ptr<=32 && ptd<=32 && ptr && ptd && get_user_team(ptr)!=get_user_team(ptd) && !tagged[ptr] && !tagged[ptd])
	{
		if(TFlag_holder==ptr || CTFlag_holder==ptr)
		{
			new name[32]
			get_user_name(ptr,name,31)
			if(ptr==TFlag_holder && ptd!=CTFlag_holder)
			{
				client_print(0,print_chat,"%L",LANG_PLAYER,"DROPT",name)
				TFlag_holder=-1
				new param[1]
				param[0]=0
				get_user_origin(ptr,TFlag_deathspot)
				set_task(0.1,"flagfall",1,param)
			}
			if(ptr==CTFlag_holder && ptd!=TFlag_holder)
			{
				client_print(0,print_chat,"%L",LANG_PLAYER,"DROPCT",name)
				CTFlag_holder=-1
				new param[1]
				param[0]=0
				get_user_origin(ptr,TFlag_deathspot)
				set_task(0.1,"flagfall",2,param)
			}
			tagged[ptr]=true
			client_print(ptr,print_chat,"%L",ptr,"GOTTAGGED",name)
			client_print(ptd,print_chat,"%L",ptd,"TAGGEDSOMEONE",name)
			set_user_rendering(ptr,kRenderFxGlowShell,255,255,255,kRenderTransAlpha,150)
		}
		if(TFlag_holder==ptd || CTFlag_holder==ptd)
		{
			new name[32]
			get_user_name(ptd,name,31)
			if(ptd==TFlag_holder && ptr!=TFlag_holder)
			{
				client_print(0,print_chat,"%L",LANG_PLAYER,"DROPT",name)
				TFlag_holder=-1
				new param[1]
				param[0]=0
				get_user_origin(ptd,TFlag_deathspot)
				set_task(0.1,"flagfall",1,param)
			}
			if(ptd==CTFlag_holder && ptr!=CTFlag_holder)
			{
				client_print(0,print_chat,"%L",LANG_PLAYER,"DROPCT",name)
				CTFlag_holder=-1
				new param[1]
				param[0]=0
				get_user_origin(ptd,TFlag_deathspot)
				set_task(0.1,"flagfall",2,param)
			}
			tagged[ptd]=true
			client_print(ptd,print_chat,"%L",ptr,"GOTTAGGED",name)
			client_print(ptr,print_chat,"%L",ptd,"TAGGEDSOMEONE",name)
			set_user_rendering(ptd,kRenderFxGlowShell,255,255,255,kRenderTransAlpha,150)
		}
		else
		{
			new origin[3]
			get_user_origin(ptr,origin)
			new team[32]
			get_user_team(ptr,team,31)
			new teamnum=1
			if(containi(team,"CT")!=-1 || containi(team,"Counter")!=-1)
			{
				teamnum=2
			}
			if(get_distance(origin,TFlag_stand)<get_distance(origin,CTFlag_stand) && teamnum==2)
			{
				tagged[ptr]=true
				client_print(ptd,print_chat,"%L",ptr,"GOTTAGGED")
				client_print(ptr,print_chat,"%L",ptd,"TAGGEDSOMEONE")
				set_user_rendering(ptr,kRenderFxGlowShell,255,255,255,kRenderTransAlpha,150)
			}
			if(get_distance(origin,TFlag_stand)>get_distance(origin,CTFlag_stand) && teamnum==1)
			{
				tagged[ptr]=true
				client_print(ptr,print_chat,"%L",ptr,"GOTTAGGED")
				client_print(ptd,print_chat,"%L",ptd,"TAGGEDSOMEONE")
				set_user_rendering(ptr,kRenderFxGlowShell,255,255,255,kRenderTransAlpha,150)
			}

			get_user_origin(ptd,origin)
			get_user_team(ptd,team,31)
			teamnum=1
			if(containi(team,"CT")!=-1 || containi(team,"Counter")!=-1)
			{
				teamnum=2
			}
			if(get_distance(origin,TFlag_stand)<get_distance(origin,CTFlag_stand) && teamnum==2)
			{
				tagged[ptd]=true
				client_print(ptd,print_chat,"%L",ptr,"GOTTAGGED")
				client_print(ptr,print_chat,"%L",ptd,"TAGGEDSOMEONE")
				set_user_rendering(ptd,kRenderFxGlowShell,255,255,255,kRenderTransAlpha,150)
			}
			if(get_distance(origin,TFlag_stand)>get_distance(origin,CTFlag_stand) && teamnum==1)
			{
				tagged[ptd]=true
				client_print(ptd,print_chat,"%L",ptr,"GOTTAGGED")
				client_print(ptr,print_chat,"%L",ptd,"TAGGEDSOMEONE")
				set_user_rendering(ptd,kRenderFxGlowShell,255,255,255,kRenderTransAlpha,150)
			}
		}
	}
	return PLUGIN_CONTINUE
}


/*********************************************************
 Deal with deaths here. (And if they died with the flag).
*********************************************************/

public DeathMsg()
{
	if(stopplugin || !get_cvar_num(cvar_ctf_enabled))
	{
		return PLUGIN_CONTINUE
	}
	if(read_data(2)==CTFlag_holder)
	{
		CTFlag_holder=-1
		new param[1]
		param[0]=0
		get_user_origin(read_data(2),CTFlag_deathspot)
		set_task(0.1,"flagfall",2,param,1)
		cs_set_user_money(read_data(1),cs_get_user_money(read_data(1)) + get_cvar_num(cvar_ctf_kill_reward))
		client_print(read_data(1),print_chat,"%L",read_data(1),"GOTKILLREWARD",get_cvar_num(cvar_ctf_kill_reward))
	}
	if(read_data(2)==TFlag_holder)
	{
		TFlag_holder=-1
		new param[1]
		param[0]=0
		get_user_origin(read_data(2),TFlag_deathspot)
		set_task(0.1,"flagfall",1,param,1)
		cs_set_user_money(read_data(1),cs_get_user_money(read_data(1)) + get_cvar_num(cvar_ctf_kill_reward))
		client_print(read_data(1),print_chat,"%L",read_data(1),"GOTKILLREWARD",get_cvar_num(cvar_ctf_kill_reward))
	}

	set_task(get_cvar_float("ctf_spawntime2")+1.0,"spawn1",read_data(2))
	return PLUGIN_CONTINUE
}

public spawn1(id)
{
	spawn(id)
	set_task(0.2,"spawn2",id)
	return PLUGIN_HANDLED
}

public spawn2(id)
{
	spawn(id)
	new team[32]
	get_user_team(id,team,31)
	give_item(id,"weapon_knife")
	if(containi(team,"CT")!=-1 || containi(team,"Counter")!=-1)
	{
		give_item(id,"weapon_usp")
		give_item(id,"ammo_45acp")
		give_item(id,"ammo_45acp")
	}
	else
	{
		give_item(id,"weapon_glock18")
		give_item(id,"ammo_9mm")
		give_item(id,"ammo_9mm")
	}
	client_print(id,print_chat,"%L",id,"SPAWNSAY",clientcmd_spawn)
	cs_set_user_money(id,cs_get_user_money(id) + 1000)

	set_task(1.0,"ungodmode",id)
	spawntimeleft[id] = get_cvar_num(cvar_ctf_spawntime)
	set_user_godmode(id,1)
	set_user_rendering(id,kRenderFxGlowShell,0,255,0,kRenderTransAlpha,150)

	can_respawn[id]=true
	set_task(15.0,"un_can_respawn",id)
	return PLUGIN_HANDLED
}

public spawn3(id)
{
	if(!can_respawn[id])
	{
		return PLUGIN_HANDLED
	}
	spawn(id)
	new team[32]
	get_user_team(id,team,31)
	strip_user_weapons(id)
	give_item(id,"weapon_knife")
	if(containi(team,"CT")!=-1 || containi(team,"Counter")!=-1)
	{
		give_item(id,"weapon_usp")
		give_item(id,"ammo_45acp")
		give_item(id,"ammo_45acp")
	}
	else
	{
		give_item(id,"weapon_glock")
		give_item(id,"ammo_9mm")
		give_item(id,"ammo_9mm")
	}

	set_user_godmode(id,1)

	set_task(get_cvar_float(cvar_ctf_spawntime),"ungodmode",id)
	return PLUGIN_HANDLED
}

public ungodmode(id)
{
	if(spawntimeleft[id]<=0)
	{
		set_user_health(id,100)
		spawntimeleft[id]=0
		set_user_godmode(id,0)
		set_user_rendering(id,kRenderFxNone,0,0,0,kRenderNormal,0)
		client_print(id,print_chat,"%L",id,"SPAWNOVER")
	}
	else
	{
		spawntimeleft[id] -= 1
		set_task(1.0,"ungodmode",id)
		client_print(id,print_chat,"%L",id,"SPAWNGOINGTOBEOVER",spawntimeleft[id])
	}
	return PLUGIN_HANDLED
}

public un_can_respawn(id)
{
	can_respawn[id]=false
	return PLUGIN_HANDLED
}

public flagfall(id,param[1])
{
	if(param[0]<3)
	{
		if(id==1)
		{
			TFlag_deathspot[2] -= 2
		}
		if(id==2)
		{
			CTFlag_deathspot[2] -= 2
		}
		param[0]++
		set_task(0.1,"flagfall",id,param,1)
	}
	return PLUGIN_HANDLED
}


/************************************
 We deal with drawing the flag here.
************************************/

public find_flagpos()
{
	new ent1 = find_ent_by_class(0,"info_player_start")
	new ent2 = find_ent_by_class(0,"info_player_deathmatch")
	if(!ent1)
	{
		log_amx("%L",LANG_SERVER,"ERROR1")
		stopplugin=true
	}
	if(!ent2)
	{
		log_amx("%L",LANG_SERVER,"ERROR2")
		stopplugin=true
	}
	new Float:CTFlag_stand_F[3]
	new Float:TFlag_stand_F[3]
	entity_get_vector(ent1,EV_VEC_origin,CTFlag_stand_F)
	entity_get_vector(ent2,EV_VEC_origin,TFlag_stand_F)
	CTFlag_stand[0] = floatround(CTFlag_stand_F[0])
	CTFlag_stand[1] = floatround(CTFlag_stand_F[1])
	CTFlag_stand[2] = floatround(CTFlag_stand_F[2])
	TFlag_stand[0] = floatround(TFlag_stand_F[0])
	TFlag_stand[1] = floatround(TFlag_stand_F[1])
	TFlag_stand[2] = floatround(TFlag_stand_F[2])
	return PLUGIN_HANDLED
}

public draw_flag_stands()
{
	if(stopplugin || !get_cvar_num(cvar_ctf_enabled))
	{
		return PLUGIN_HANDLED
	}
	create_sprite_message(CTFlag_stand[0],CTFlag_stand[1],CTFlag_stand[2],CTFlag_stand[0] - 34,CTFlag_stand[1],CTFlag_stand[2] - 50,100,5,0,255,0)
	create_sprite_message(CTFlag_stand[0],CTFlag_stand[1],CTFlag_stand[2],CTFlag_stand[0] + 34,CTFlag_stand[1],CTFlag_stand[2] - 50,100,5,0,255,0)
	create_sprite_message(CTFlag_stand[0],CTFlag_stand[1],CTFlag_stand[2],CTFlag_stand[0],CTFlag_stand[1] - 34,CTFlag_stand[2] - 50,100,5,0,255,0)
	create_sprite_message(CTFlag_stand[0],CTFlag_stand[1],CTFlag_stand[2],CTFlag_stand[0],CTFlag_stand[1] + 34,CTFlag_stand[2] - 50,100,5,0,255,0)
	
	create_sprite_message(TFlag_stand[0],TFlag_stand[1],TFlag_stand[2],TFlag_stand[0] - 34,TFlag_stand[1],TFlag_stand[2] - 50,100,5,0,255,0)
	create_sprite_message(TFlag_stand[0],TFlag_stand[1],TFlag_stand[2],TFlag_stand[0] + 34,TFlag_stand[1],TFlag_stand[2] - 50,100,5,0,255,0)
	create_sprite_message(TFlag_stand[0],TFlag_stand[1],TFlag_stand[2],TFlag_stand[0],TFlag_stand[1] - 34,TFlag_stand[2] - 50,100,5,0,255,0)
	create_sprite_message(TFlag_stand[0],TFlag_stand[1],TFlag_stand[2],TFlag_stand[0],TFlag_stand[1] + 34,TFlag_stand[2] - 50,100,5,0,255,0)
	return PLUGIN_HANDLED
}

public draw_flags()
{
	if(stopplugin || !get_cvar_num(cvar_ctf_enabled))
	{
		return PLUGIN_HANDLED
	}
	new CTFlag_origin[3]
	new TFlag_origin[3]
	if(!CTFlag_holder)
	{
		CTFlag_origin[0] = CTFlag_stand[0]
		CTFlag_origin[1] = CTFlag_stand[1]
		CTFlag_origin[2] = CTFlag_stand[2]
	}
	if(!TFlag_holder)
	{
		TFlag_origin[0] = TFlag_stand[0]
		TFlag_origin[1] = TFlag_stand[1]
		TFlag_origin[2] = TFlag_stand[2]
	}
	if(CTFlag_holder!=-1 && CTFlag_holder)
	{
		get_user_origin(CTFlag_holder,CTFlag_origin)
	}
	if(TFlag_holder!=-1 && TFlag_holder)
	{
		get_user_origin(TFlag_holder,TFlag_origin)
	}
	if(CTFlag_holder==-1)
	{
		CTFlag_origin[0] = CTFlag_deathspot[0]
		CTFlag_origin[1] = CTFlag_deathspot[1]
		CTFlag_origin[2] = CTFlag_deathspot[2]
	}
	if(TFlag_holder==-1)
	{
		TFlag_origin[0] = TFlag_deathspot[0]
		TFlag_origin[1] = TFlag_deathspot[1]
		TFlag_origin[2] = TFlag_deathspot[2]
	}
	if(flag_exists && get_cvar_num("ctf_flagmodels"))
	{
		new Float:F_CTFlag_origin[3]
		new Float:F_TFlag_origin[3]
		IVecFVec(CTFlag_origin,F_CTFlag_origin)
		IVecFVec(TFlag_origin,F_TFlag_origin)
		F_CTFlag_origin[2] += 50.0
		F_TFlag_origin[2] += 50.0
		entity_set_vector(ctflagent,EV_VEC_origin,F_CTFlag_origin)
		entity_set_vector(tflagent,EV_VEC_origin,F_TFlag_origin)
	}
	else
	{
		create_sprite_message(TFlag_origin[0],TFlag_origin[1],TFlag_origin[2],TFlag_origin[0],TFlag_origin[1],TFlag_origin[2] + 50,1,5,255,255,255)
		create_sprite_message(CTFlag_origin[0],CTFlag_origin[1],CTFlag_origin[2],CTFlag_origin[0],CTFlag_origin[1],CTFlag_origin[2] + 50,1,5,255,255,255)
	
		create_sprite_message(TFlag_origin[0],TFlag_origin[1],TFlag_origin[2] + 40,TFlag_origin[0],TFlag_origin[1],TFlag_origin[2] + 50,1,40,255,0,0)
		create_sprite_message(CTFlag_origin[0],CTFlag_origin[1],CTFlag_origin[2] + 40,CTFlag_origin[0],CTFlag_origin[1],CTFlag_origin[2] + 50,1,40,0,0,255)
	}
	return PLUGIN_HANDLED
}

public create_sprite_message(origin1_1,origin1_2,origin1_3,origin2_1,origin2_2,origin2_3,life,width,red,green,blue)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
	write_byte(0)		//TE_BEAMPOINTS
	write_coord(origin1_1)
	write_coord(origin1_2)
	write_coord(origin1_3)
	write_coord(origin2_1)
	write_coord(origin2_2)
	write_coord(origin2_3)
	write_short(beamsprite)
	write_byte(1)		// framestart
	write_byte(1)		// framerate
	write_byte(life)	// life in 0.1's
	write_byte(width)	// width
	write_byte(0)		// noise
	write_byte(red)		// red
	write_byte(green)	// green
	write_byte(blue)	// blue
	write_byte(200)		// brightness
	write_byte(0)		// speed
	message_end()
	return PLUGIN_HANDLED
}


/***************************************************************
 Specifically creates the giant line in the middle on tag mode.
***************************************************************/

public create_middle1()
{
	if(stopplugin)
	{
		return PLUGIN_HANDLED
	}
	
	//***
	//Simple Algebra to calculate the location of the middle line(s).
	//***
	
	new Float:CTFlag_stand_F[3]
	new Float:TFlag_stand_F[3]
	IVecFVec(CTFlag_stand,CTFlag_stand_F)
	IVecFVec(TFlag_stand,TFlag_stand_F)
	
	new Float:line1_slope = (CTFlag_stand_F[1] - TFlag_stand_F[1]) / (CTFlag_stand_F[0] - TFlag_stand_F[0])
	new Float:line2_slope = -1.0 * (1.0 / line1_slope)
	
	new Float:midpoint[3]
	midpoint[0] = (CTFlag_stand_F[0] + TFlag_stand_F[0]) / 2
	midpoint[1] = (CTFlag_stand_F[1] + TFlag_stand_F[1]) / 2
	midpoint[2] = (CTFlag_stand_F[2] + TFlag_stand_F[2]) / 2
	
	//>1 = go by Y
	//<1 = go by X
	//Add 4000 units on Q
	//Add 1000 units on Z
	//tag_sprite_size_horizontal	4000
	//tag_sprite_size_vertical	1000
	
	if(floatabs(line2_slope)>1.0)
	{
		farthest_point1[1] = midpoint[1] + (tag_sprite_size_horizontal / 2)
		farthest_point2[1] = midpoint[1] - (tag_sprite_size_horizontal / 2)
		
		farthest_point1[0] = (farthest_point1[1] - midpoint[1] + (line2_slope * midpoint[0])) / line2_slope
		farthest_point2[0] = (farthest_point2[1] - midpoint[1] + (line2_slope * midpoint[0])) / line2_slope
	}
	
	if(floatabs(line2_slope)<=1.0)
	{
		farthest_point1[0] = midpoint[0] + (tag_sprite_size_horizontal / 2)
		farthest_point2[0] = midpoint[0] - (tag_sprite_size_horizontal / 2)

		farthest_point1[1] = line2_slope*(farthest_point1[0]-midpoint[0]) + midpoint[1]
		farthest_point2[1] = line2_slope*(farthest_point2[0]-midpoint[0]) + midpoint[1]
	}
	
	farthest_point1[2] = midpoint[2] - (tag_sprite_size_vertical / 2)
	
	set_task(0.1,"create_middle2")
	
	return PLUGIN_HANDLED
}

public create_middle2()
{
	if(stopplugin || !get_cvar_num(cvar_ctf_enabled))
	{
		return PLUGIN_HANDLED
	}
	if(!get_cvar_num(cvar_ctf_tagmode) && !get_cvar_num("ctf_fence"))
	{
		return PLUGIN_HANDLED
	}
	for(new Float:i=1.0;i<=(tag_sprite_size_vertical / tag_sprite_vertical_increments);i += 1.0)
	{
		new Float:zpoint = farthest_point1[2] + (i * tag_sprite_vertical_increments)

		set_task((i * 0.1),"create_middle3",floatround(zpoint))
	}
	return PLUGIN_HANDLED
}

public create_middle3(id)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
	write_byte(0)		//TE_BEAMPOINTS
	write_coord(floatround(farthest_point1[0]))
	write_coord(floatround(farthest_point1[1]))
	write_coord(id)
	write_coord(floatround(farthest_point2[0]))
	write_coord(floatround(farthest_point2[1]))
	write_coord(id)
	write_short(beamsprite)
	write_byte(1)		// framestart
	write_byte(1)		// framerate
	write_byte(150)		// life in 0.1's
	write_byte(5)		// width
	write_byte(0)		// noise
	write_byte(0)		// red
	write_byte(255)		// green
	write_byte(0)		// blue
	write_byte(200)		// brightness
	write_byte(0)		// speed
	message_end()
	return PLUGIN_HANDLED
}


/*****************************************************
 Help users play CTF with the say /ctf_help function.
*****************************************************/

public hook_say_help(id)
{
	new MOTDname[32]
	format(MOTDname,31,"%L",id,"MOTD1-8")
	if(get_cvar_num(cvar_ctf_tagmode))
	{
		new MOTDBody[1400]
		new len = format(MOTDBody,1399,"%L",id,"MOTD1-0")
		len += format(MOTDBody[len],1399-len, "<BR>")
		len += format(MOTDBody[len],1399,"%L",id,"MOTD1-1")
		len += format(MOTDBody[len],1399,"%L",id,"MOTD1-2")
		len += format(MOTDBody[len],1399,"%L",id,"MOTD1-3")
		len += format(MOTDBody[len],1399,"%L",id,"MOTD1-4")
		len += format(MOTDBody[len],1399,"%L",id,"MOTD1-5")
		len += format(MOTDBody[len],1399,"%L",id,"MOTD1-6")
		len += format(MOTDBody[len],1399,"%L",id,"MOTD1-7")
		show_motd(id,MOTDBody,MOTDname)
	}
	if(!get_cvar_num(cvar_ctf_tagmode))
	{
		new MOTDBody[1400]
		new len = format(MOTDBody,1399,"%L",id,"MOTD2-0")
		len += format(MOTDBody[len],1399-len, "<BR>")
		len += format(MOTDBody[len],1399,"%L",id,"MOTD2-1")
		len += format(MOTDBody[len],1399,"%L",id,"MOTD2-2")
		len += format(MOTDBody[len],1399,"%L",id,"MOTD2-3")
		len += format(MOTDBody[len],1399,"%L",id,"MOTD2-4")
		show_motd(id,MOTDBody,MOTDname)
	}
	return PLUGIN_CONTINUE
}

public Advertise()
{
	if(get_cvar_num(cvar_ctf_enabled))
	{
		client_print(0,print_chat,"%L",LANG_PLAYER,"SAYHELPADVERTISE",clientcmd_help)
	}
	return PLUGIN_HANDLED
}


/*****************************
 Toggle command for Tag Mode.
*****************************/

public cvar_toggle(id,level,cid)
{
	if(!cmd_access(id,level,cid,2))
	{
		return PLUGIN_HANDLED
	}
	
	new arg1[32]
	read_argv(1,arg1,31)
	
	if(str_to_num(arg1) || equali(arg1,"on"))
	{
		client_print(0,print_chat,"%L",LANG_PLAYER,"TAGENABLED")
		console_print(id,"%L",id,"TAGENABLED")
		set_cvar_num(cvar_ctf_tagmode,1)
	}
	else
	{
		client_print(0,print_chat,"%L",LANG_PLAYER,"TAGDISABLED")
		console_print(id,"%L",id,"TAGDISABLED")
		set_cvar_num(cvar_ctf_tagmode,0)
	}
	server_cmd("sv_restartround 3")
	return PLUGIN_HANDLED
}

public cvar2_toggle(id,level,cid)
{
	if(!cmd_access(id,level,cid,2))
	{
		return PLUGIN_HANDLED
	}
	
	new arg1[32]
	read_argv(1,arg1,31)
	
	if(str_to_num(arg1) || equali(arg1,"on"))
	{
		client_print(0,print_chat,"%L",LANG_PLAYER,"PLUGINENABLED")
		console_print(id,"%L",id,"PLUGINENABLED")
		set_cvar_num(cvar_ctf_enabled,1)
	}
	else
	{
		client_print(0,print_chat,"%L",LANG_PLAYER,"PLUGINDISABLED")
		console_print(id,"%L",id,"PLUGINDISABLED")
		set_cvar_num(cvar_ctf_enabled,0)
		new Float:origin[3]
		origin[0] = 9999.0
		origin[1] = 9999.0
		origin[2] = 9999.0
		if(is_valid_ent(ctflagent)) entity_set_origin(ctflagent,origin)
		if(is_valid_ent(tflagent)) entity_set_origin(tflagent,origin)
	}
	server_cmd("sv_restartround 3")
	return PLUGIN_HANDLED
}


/*************************************************
 Removes weapon entities on ground to lessen lag.
*************************************************/
public Remove_Weapons()
{
	new modelname[32]
	for(new i=33;i<=1500;i++)
	{
		if(is_valid_ent(i))
		{
			entity_get_string(i,EV_SZ_model,modelname,31)
			if(containi(modelname,"w_")!=-1)
			{
				remove_entity(i)
			}
		}
	}
	return PLUGIN_HANDLED
}


/*******************************************
 Removes C4 from game while CTF is enabled.
*******************************************/
public drop_c4(id)
{
	if(get_cvar_num(cvar_ctf_enabled))
	{
		client_cmd(id,"drop")
	}
	return PLUGIN_CONTINUE
}


/****************************************************
 A. Removes Hostages from game while CTF is enabled.
 B. When round ends flags are placed back at bases.
****************************************************/
public newround()
{
	set_task(1.0,"remove_hostages")
	CTFlag_holder=0
	TFlag_holder=0
	return PLUGIN_CONTINUE
}

public remove_hostages()
{
	if(!get_cvar_num(cvar_ctf_enabled))
	{
		return PLUGIN_CONTINUE
	}
	new Float:origin[3]
	origin[0]=9999.0
	origin[1]=9999.0
	origin[2]=9999.0
	new ent = find_ent_by_class(33,"hostage_entity")
	while(ent)
	{
		entity_set_vector(ent,EV_VEC_origin,origin)
		ent = find_ent_by_class(ent,"hostage_entity")
	}
	return PLUGIN_CONTINUE
}
