#include <amxmodx>
#include <amxmisc>
#include <fun>
#include <cstrike>

new const primweapons[18][32] = 
{
	"",
	"weapon_xm1014",
	"weapon_mac10",
	"weapon_scout",
	"weapon_aug",
	"weapon_ump45",
	"weapon_sg550",
	"weapon_galil",
	"weapon_famas",
	"weapon_awp",
	"weapon_mp5navy",
	"weapon_m249",
	"weapon_m3",
	"weapon_m4a1",
	"weapon_tmp",
	"weapon_g3sg1",
	"weapon_sg552",
	"weapon_ak47"
}

new const primweaponsammo[18][32] = 
{
	"",
	"weapon_xm1014",
	"ammo_45acp",
	"ammo_762nato",
	"ammo_556nato",
	"ammo_45acp",
	"ammo_556nato",
	"ammo_556nato",
	"ammo_556nato",
	"ammo_338magnum",
	"ammo_9mm",
	"ammo_556nato",
	"weapon_m3",
	"ammo_556nato",
	"ammo_9mm",
	"ammo_762nato",
	"ammo_556nato",
	"ammo_762nato"
}

new const secweapons[8][32] = 
{
	"",
	"weapon_p228",
	"weapon_elite",
	"weapon_fiveseven",
	"weapon_usp",
	"weapon_glock18",
	"weapon_deagle",
	"weapon_p90"
}

new const secweaponsammo[8][32] = 
{
	"",
	"ammo_357sig",
	"ammo_9mm",
	"ammo_57mm",
	"ammo_45acp",
	"ammo_9mm",
	"ammo_50ae",
	"ammo_57mm"
}

new togglecvar, respawntime, invincible, primweapon, secweapon, henade, flashnade, smokenade, armor, knife,  spawnmoney
new bool:respawning[33]

public plugin_init()
{
	register_plugin("GHW CTF Respawner","1.0","GHW_Chronic")
	togglecvar = get_cvar_pointer("ctf_enabled")
	respawntime = register_cvar("ctf_respawntime","0.0")
	invincible = register_cvar("ctf_invincible","5.0")
	primweapon = register_cvar("ctf_primweapon","-1")
	secweapon = register_cvar("ctf_secweapon","-1")
	henade = register_cvar("ctf_henade","1")
	flashnade = register_cvar("ctf_flashnade","1")
	smokenade = register_cvar("ctf_smokenade","0")
	armor = register_cvar("ctf_armor","2")
	knife = register_cvar("ctf_knife","1")
	spawnmoney = register_cvar("ctf_spawnmoney","1800")

	register_event("DeathMsg","DeathMsg","a")
	register_message(get_user_msgid("TextMsg"),"catch_jointeam")
}

public client_putinserver(id) set_task(1.0,"catch_jointeam",id,"",0,"b")

public catch_jointeam()
{
	if(get_pcvar_num(togglecvar))
	{
		if(get_msg_args()==3 && get_msg_argtype(2)==ARG_STRING && get_msg_argtype(3)==ARG_STRING)
		{
			new message[32]
			get_msg_arg_string(2,message,31)
			if(equali(message,"#Game_join_terrorist") || equali(message,"#Game_join_ct"))
			{
				get_msg_arg_string(3,message,31)
				new id = cmd_target(0,message,0)
				if(id)
				{
					remove_task(id)
					set_task(5.0,"spawn1",id)
					respawning[id]=true
				}
			}
		}

	}
}

public DeathMsg()
{
	if(get_pcvar_num(togglecvar))
	{
		if(cs_get_user_team(read_data(2))!=CS_TEAM_SPECTATOR)
		{
			set_task(get_pcvar_float(respawntime),"spawn1",read_data(2))
			respawning[read_data(2)]=true
		}
	}
}

public spawn1(id)
{
	if(cs_get_user_team(id)!=CS_TEAM_SPECTATOR)
	{
		spawn(id)
		set_task(0.6,"spawn2",id)
		set_user_godmode(id,1)
	}
}

public spawn2(id)
{
	if(cs_get_user_team(id)!=CS_TEAM_SPECTATOR)
	{
		spawn(id)
		set_task(0.6,"spawn3",id)
		set_user_godmode(id,1)
	}
}

public spawn3(id)
{
	if(cs_get_user_team(id)!=CS_TEAM_SPECTATOR)
	{
		spawn(id)
		strip_user_weapons(id)
		set_user_godmode(id,1)
		set_task(get_pcvar_float(invincible),"ungodmode",id)
		set_user_rendering(id,kRenderFxGlowShell,255,255,255,kRenderTransAlpha,70)
		cs_set_user_money(id,get_pcvar_num(spawnmoney) + cs_get_user_money(id),1)
	}
}

public ungodmode(id)
{
	set_user_godmode(id,0)
	set_user_rendering(id,kRenderFxNone,0,0,0,kRenderTransAlpha,255)

	if(get_pcvar_num(knife)) give_item(id,"weapon_knife")

	new prim = get_pcvar_num(primweapon)
	new sec = get_pcvar_num(secweapon)
	if(prim>0 && prim<17)
	{
		give_item(id,primweapons[prim])
		give_item(id,primweaponsammo[prim])
		give_item(id,primweaponsammo[prim])
		give_item(id,primweaponsammo[prim])
	}
	else if(prim<0)
	{
		switch(cs_get_user_team(id))
		{
			case CS_TEAM_T:
			{
				give_item(id,primweapons[17])
				give_item(id,primweaponsammo[17])
				give_item(id,primweaponsammo[17])
				give_item(id,primweaponsammo[17])
			}
			case CS_TEAM_CT:
			{
				give_item(id,primweapons[13])
				give_item(id,primweaponsammo[13])
				give_item(id,primweaponsammo[13])
				give_item(id,primweaponsammo[13])
			}
		}
	}

	if(sec>0 && sec<7)
	{
		give_item(id,secweapons[sec])
		give_item(id,secweaponsammo[sec])
		give_item(id,secweaponsammo[sec])
		give_item(id,secweaponsammo[sec])
		give_item(id,secweaponsammo[sec])
		give_item(id,secweaponsammo[sec])
		give_item(id,secweaponsammo[sec])
		give_item(id,secweaponsammo[sec])
	}
	else if(sec<0)
	{
		switch(cs_get_user_team(id))
		{
			case CS_TEAM_T:
			{
				give_item(id,secweapons[5])
				give_item(id,secweaponsammo[5])
				give_item(id,secweaponsammo[5])
				give_item(id,secweaponsammo[5])
				give_item(id,secweaponsammo[5])
				give_item(id,secweaponsammo[5])
				give_item(id,secweaponsammo[5])
				give_item(id,secweaponsammo[5])
			}
			case CS_TEAM_CT:
			{
				give_item(id,secweapons[4])
				give_item(id,secweaponsammo[4])
				give_item(id,secweaponsammo[4])
				give_item(id,secweaponsammo[4])
				give_item(id,secweaponsammo[4])
				give_item(id,secweaponsammo[4])
				give_item(id,secweaponsammo[4])
				give_item(id,secweaponsammo[4])
			}
		}
	}

	if(get_pcvar_num(henade)) give_item(id,"weapon_hegrenade")
	if(get_pcvar_num(flashnade)) give_item(id,"weapon_flashbang")
	if(get_pcvar_num(flashnade)>1) give_item(id,"weapon_flashbang")
	if(get_pcvar_num(smokenade)) give_item(id,"weapon_smokegrenade")

	switch(get_pcvar_num(armor))
	{
		case 1:
		{
			cs_set_user_armor(id,100,CS_ARMOR_KEVLAR)
		}
		case 2:
		{
			cs_set_user_armor(id,100,CS_ARMOR_VESTHELM)
		}
	}
}
